'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _withInitialProps = require('./withInitialProps');

var _withInitialProps2 = _interopRequireDefault(_withInitialProps);

var _createClientContextFactoryParams = require('./createClientContextFactoryParams');

var _createClientContextFactoryParams2 = _interopRequireDefault(_createClientContextFactoryParams);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var EMPTY_GET_INITIAL_PROPS = function EMPTY_GET_INITIAL_PROPS() {
  return _promise2.default.resolve({});
};

var createUniversalPage = function createUniversalPage(contextFactory, routeInfo) {
  return function (_ref) {
    var Page = _ref.default;

    // check if the Page page has a getInitialProps, if not put a resolve with an empty object
    Page.getInitialProps = typeof Page.getInitialProps === 'function' ? Page.getInitialProps : EMPTY_GET_INITIAL_PROPS;
    // check if we're on the client
    if (typeof window !== 'undefined') {
      // check if we have already data for this component on the window
      if (typeof window.__INITIAL_PROPS__ !== 'undefined') {
        // make a copy of the content safely
        var initialProps = (0, _extends3.default)({}, window.__INITIAL_PROPS__);
        // remove the variable of the window before returning the component
        delete window.__INITIAL_PROPS__;
        // resolve the promise with the initialProps passed to the client
        return _promise2.default.resolve(function (props) {
          return _react2.default.createElement(Page, (0, _extends3.default)({}, initialProps, props));
        });
      }
      // create the context to be used as param on the getInitialProps
      // TODO: Maybe this is no needed as we already have created it?
      return contextFactory((0, _createClientContextFactoryParams2.default)())
      // now, we have to create the Page to be rendered on the client with all the info
      .then(function (context) {
        return (0, _withInitialProps2.default)({ context: context, routeInfo: routeInfo })(Page);
      });
    }
    // we're in the server, so return just the component and pass the initialProps from the context
    var ServerPage = function ServerPage(props, _ref2) {
      var _ref2$initialProps = _ref2.initialProps,
          initialProps = _ref2$initialProps === undefined ? {} : _ref2$initialProps;
      return _react2.default.createElement(Page, (0, _extends3.default)({}, props, initialProps));
    };
    // recover the initialProps if in the server we have retrieved them
    ServerPage.contextTypes = { initialProps: _react.PropTypes.object
      // detect if the page has getInitialProps and wrap it with the routeInfo
      // if we don't have any getInitialProps, just use a empty function returning an empty object
    };ServerPage.getInitialProps = function (context) {
      return Page.getInitialProps({ context: context, routeInfo: routeInfo });
    };
    // return the component to be used on the server
    return ServerPage;
  };
};

exports.default = function (contextFactory, importPage) {
  return function (routeInfo, done) {
    importPage().then(createUniversalPage(contextFactory, routeInfo)).then(function (Page) {
      done(null, Page);
    });
  };
};